// BroadcastDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Broadcast.h"
#include "BroadcastDlg.h"
#include <io.h>
#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND hWnd;
LPBITMAPINFOHEADER lpbi;
LPBYTE lpdib;
HANDLE hBoard;
char szFileName[128]="\0";
char	str[100];
long	thControl;
BLOCKINFO blk;
int		color=0;
RECT scrrect;
BOOL	DecDate=1,DecTime=1,DecMilSec=1;
LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
SETTEXTMODE	textmode={0xff0000,0xffffff,2,0,0};
BOOL exGetLoadName(HWND hWnd, char *szFileName);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
static void WINAPI DecodeThread();
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBroadcastDlg dialog

CBroadcastDlg::CBroadcastDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBroadcastDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBroadcastDlg)
	m_color = 0;
	m_framenum = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CBroadcastDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBroadcastDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	DDX_Radio(pDX, IDC_RADIO1, m_color);
	DDX_Text(pDX, IDC_EDITFRMNUM, m_framenum);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBroadcastDlg, CDialog)
	//{{AFX_MSG_MAP(CBroadcastDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBroadcastDlg message handlers

BOOL CBroadcastDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	MLONG  lIndex=-1;	
	hBoard=okOpenBoard(&lIndex); //򿪿
	if (!hBoard)
	{
		MessageBox("򿪿ʧܣ", NULL, MB_OK);
	}
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
	SetRect(&scrrect,0,0,1,1);

	((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_CHECK2))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_CHECK3))->SetCheck(1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBroadcastDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBroadcastDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if (lpbi)
		{
			CDC *cdc;
			RECT rect;
			
			cdc=m_image.GetDC();
			
			m_image.GetClientRect(&rect);
			SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
			StretchDIBits(cdc->m_hDC,
				rect.left,rect.top,
				rect.right,rect.bottom, 
				0,0, //horzstart, vertstart, 
				lpbi->biWidth,lpbi->biHeight,
				lpdib,(LPBITMAPINFO)lpbi, 
				DIB_RGB_COLORS,SRCCOPY);
			
			ReleaseDC(cdc);
		}
		CDialog::OnPaint();
		
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBroadcastDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

static void WINAPI DecodeThread()
{
	HANDLE		hFile;
	EXTRAFRMINFO	ExtraFrmInfo;
	MJPGHEADER	MjpgHeader;
	HANDLE		hDecode;
	DWORD		lReadLen,lRestLen;
	MLONG 		lDecLen;
	LPBYTE		lpDecBuf,lpData;
	RECT		rect;
	long		form;
	BOOL        bFrmNum=0,bTimeStamp=0;
	
	lpDecBuf = (LPBYTE)GlobalAlloc(GPTR,1024*1024*5);
	if (lpDecBuf == NULL)
	{
		MessageBox(NULL, "ڴʧܣ", NULL, MB_OK);
	}
	hFile = CreateFile(szFileName,GENERIC_READ ,FILE_SHARE_READ, NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if (hFile)
	{
		ReadFile(hFile,lpDecBuf,1024*1024*1,&lReadLen,NULL);
		memset(&MjpgHeader,0,sizeof(MJPGHEADER));
		memset(&ExtraFrmInfo,0,sizeof(EXTRAFRMINFO));
		MjpgHeader.dwGetFrmInfo = MJPG_GINF;	
		MjpgHeader.lpExtraInfo = (LPVOID)&ExtraFrmInfo;
		if (hBoard)
		{
			hDecode = okBeginDecode(hBoard,CODE_MJPG,lpDecBuf,(MLONG)&MjpgHeader);
			if (hDecode==0)
			{
				MessageBox(NULL,"",NULL,MB_OK);
				GlobalFree(lpDecBuf);
				CloseHandle(hFile);
				return;
			}
			lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,MjpgHeader.lHorzSize*MjpgHeader.lVertSize*4+5120);
			lpdib=(LPBYTE)lpbi+5120;
			SetRect(&rect,0,0,MjpgHeader.lHorzSize,MjpgHeader.lVertSize);
			okSetTargetRect(hBoard,BUFFER,&rect);
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			exSetBitmapHeader(lpbi, (short)MjpgHeader.lHorzSize,(short)MjpgHeader.lVertSize, HIWORD(form), LOWORD(form) );
			blk.lpBits=lpdib;
			blk.iBitCount=lpbi->biBitCount;
			blk.iHeight =-(short)lpbi->biHeight;
			blk.iWidth =(short)lpbi->biWidth;
			SetFilePointer(hFile,0,NULL,FILE_BEGIN);
		//	SetFilePointer(hFile,-1024*1024,NULL,FILE_END);
			lRestLen=0;
			SetWindowText(GetDlgItem(hWnd, IDC_DESCRIBE1), "");
			SetWindowText(GetDlgItem(hWnd, IDC_DESCRIBE2), "");
			while (thControl && lReadLen!=0)
			{
				if (ReadFile(hFile,lpDecBuf+lRestLen,1024*1024*4,&lReadLen,NULL))
				{
					lpData=lpDecBuf;
					lRestLen=lReadLen+lRestLen;
					lDecLen=lRestLen;
					while (thControl && lReadLen!=0 && lRestLen>0)
					{	
						if (okDecodeImage(hDecode,lpData,&lDecLen,BUFFER,0) > 0)
						{
							if (bFrmNum==0&&ExtraFrmInfo.dwFrmNumber==0xffffffff)
							{
								SetWindowText(GetDlgItem(hWnd, IDC_DESCRIBE1), "ļû֡š");
								bFrmNum=1;
								ShowWindow(GetDlgItem(hWnd, IDC_STATICFRMNUM), SW_HIDE);
								ShowWindow(GetDlgItem(hWnd, IDC_EDITFRMNUM), SW_HIDE);
							}
							else
							{
								ShowWindow(GetDlgItem(hWnd, IDC_STATICFRMNUM), SW_SHOWNORMAL);
								ShowWindow(GetDlgItem(hWnd, IDC_EDITFRMNUM), SW_SHOWNORMAL);
								sprintf(str,"%d",ExtraFrmInfo.dwFrmNumber);
								SetWindowText(GetDlgItem(hWnd, IDC_EDITFRMNUM),str);
							}
							if (bTimeStamp==0&&ExtraFrmInfo.dwTimeStamp==0xffffffff)
							{
								SetWindowText(GetDlgItem(hWnd, IDC_DESCRIBE2), "ļûʱ");
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK1),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK2),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK3),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_STATIC),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO1),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO2),FALSE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO3),FALSE);
								bTimeStamp=1;
							}
							if (ExtraFrmInfo.dwTimeStamp!=0xffffffff)
							{
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK1),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK2),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_CHECK3),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_STATIC),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO1),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO2),TRUE);
								EnableWindow(GetDlgItem(hWnd,IDC_RADIO3),TRUE);
							}
							lpData=lpData+lDecLen;
							lRestLen=lRestLen-lDecLen;
							lDecLen=lRestLen;
							if (ExtraFrmInfo.dwTimeStamp!=0xffffffff)
							{
								switch(color)
								{
								case 0:
									textmode.dwForeColor=0x0000ff;
									break;
									
								case 1:
									textmode.dwForeColor=0x00ff00;
									break;
									
								case 2:
									textmode.dwForeColor=0xffff00;
									break;
								}
								
								textmode.wFrameNo=SHORT(0);
								if (DecDate==1)
								{
									SetRect(&rect,20,20,0,0);
									sprintf(str,"%04d-%02d-%02d",ExtraFrmInfo.Year,ExtraFrmInfo.Mon,ExtraFrmInfo.Day);
									okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode,str, strlen(str)); 
								}
								if (DecTime==1)
								{
									SetRect(&rect,150,20,0,0);
									//SetRect(&rect,20,20,0,0);
									int hour,minite,second;
									second=(ExtraFrmInfo.dwTimeStamp/1000)%60;
									minite=ExtraFrmInfo.dwTimeStamp/(1000*60)%60;
									hour=ExtraFrmInfo.dwTimeStamp/(1000*60*60);
									sprintf(str,"%02d:%02d:%02d",hour,minite,second);
									okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode,str, strlen(str)); 
								}
								if (DecMilSec==1)
								{
									SetRect(&rect,260,20,0,0);
									int milli;
									milli=ExtraFrmInfo.dwTimeStamp%1000;
									sprintf(str,"%03d",milli);
									okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode,str, strlen(str)); 
								}
							}
							
							okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,0,1);
							InvalidateRect(hWnd,&scrrect,FALSE);
							//			InvalidateRect(hWnd,NULL,FALSE);
							UpdateWindow(hWnd);
							
						} 
						else
						{
							memcpy(lpDecBuf,lpData,lRestLen);
							ZeroMemory(lpDecBuf+lRestLen,5*1024*1024-lRestLen);
							break;
						}					
					}
				}
			}			
			okEndDecode(hDecode);
			CloseHandle(hFile);
			hDecode=NULL;
			GlobalFree(lpDecBuf);
		}
	}
}

void CBroadcastDlg::OnStart() 
{
	thControl=1;
	if (exGetLoadName(hWnd, szFileName))
	{
		CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)DecodeThread,NULL,0,NULL);
	}
    else
		MessageBox("ļ",NULL,MB_OK);
}

BOOL exGetLoadName(HWND hWnd, char *szFileName)
{
	OPENFILENAME ofn;	 
	char		*szFilter=

		"Audio-video interleaved (*.AVI)\0*.AVI\0";

    ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 128;
    ofn.Flags		  	= OFN_HIDEREADONLY;
	
    if (! GetOpenFileName ((LPOPENFILENAME)&ofn)) {
		return FALSE;
	}
	return TRUE;
	
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;
	
	if(!lpbi)
		return FALSE;
	
	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align
	
	lpbi->biWidth=width;
	lpbi->biHeight=height;
	
	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;
	
	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;
	
	
	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);
		
		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) 
	{ // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);
		
		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;
		
		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
		
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;
	
	return lpbi->biClrUsed;
}

void CBroadcastDlg::OnStop() 
{
	thControl=0;
	
}

void CBroadcastDlg::OnClose() 
{
	thControl=0;
	GlobalFree(lpbi);
	okCloseBoard(hBoard);
	
	CDialog::OnClose();
}

void CBroadcastDlg::OnRadio1() 
{
	UpdateData(TRUE);
	color=m_color;
}

void CBroadcastDlg::OnRadio2() 
{
	UpdateData(TRUE);
	color=m_color;
}

void CBroadcastDlg::OnRadio3() 
{
	UpdateData(TRUE);
	color=m_color;
}

void CBroadcastDlg::OnCheck1() 
{
	DecDate = !DecDate;
	
}

void CBroadcastDlg::OnCheck2() 
{
	DecTime = !DecTime;
	
}

void CBroadcastDlg::OnCheck3() 
{
	DecMilSec = !DecMilSec;
	
}
